#include <filesystem>
#include <string>
#include <cstring>
#include <limits.h>
#include <codecvt>


namespace application {
namespace {  

  inline int get_next_index_path(const char* a_path, int a_index) {
    ++a_index;
    while(a_path[a_index] == '/' && a_path[a_index + 1] == '/')
      ++a_index;
    if (a_path[a_index] == '/' && a_path[a_index + 1] == 0)
      ++a_index;
    return a_index;
  }

  bool cmp_path_template(const char* a_template, const char* a_path, bool* a_dst_isfull, int* a_dst_cmp_counter) {
    int cmp_counter = 0;
    int tindex = 0;
    while(a_template[tindex] == '/')
      ++tindex;
    int pindex = 0;
    while(a_path[pindex] == '/')
      ++pindex;
    while(true){
      if (a_template[tindex] == 0 && a_path[pindex] == 0) {
        *a_dst_isfull = true;
        *a_dst_cmp_counter = cmp_counter;
        return true;
      } else if (a_template[tindex] == '*') {
        *a_dst_isfull = false;
        *a_dst_cmp_counter = cmp_counter;
        return true;
      } else if (a_template[tindex] != a_path[pindex]) {
        *a_dst_isfull = false;
        *a_dst_cmp_counter = INT_MAX;
        return false;
      } else if (a_template[tindex] == '/') {
        ++cmp_counter;
      }
      tindex = get_next_index_path(a_template, tindex);
      pindex = get_next_index_path(a_path, pindex);
    }
  }


}
}
